SystemOrganization addCategory: #HolyLight!

PRComponent subclass: #HLComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HolyLight'!

!HLComponent class methodsFor: 'accessing' stamp: 'lr 8/1/2007 11:12'!
label
	^ super label , ' (Safe Halos)'! !

!HLComponent methodsFor: 'visiting' stamp: 'pmm 7/27/2007 18:57'!
accept: aVisitor
	aVisitor visitHolyLight: self! !

!HLComponent methodsFor: 'accessing' stamp: 'pmm 7/28/2007 10:20'!
component
	^HLHalo on: super component! !

WABrowser subclass: #HLBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HolyLight'!

!HLBrowser methodsFor: 'accessing' stamp: 'pmm 7/27/2007 07:01'!
accept
	self inform: 'If this wasn''t a demo, your changes would be accepted now.'! !

!HLBrowser methodsFor: 'testing' stamp: 'pmm 8/1/2007 12:02'!
isEnabled: aSymbol
	^(#(systemCategory class) includes: aSymbol) not! !

!HLBrowser methodsFor: 'rendering' stamp: 'pmm 8/1/2007 12:06'!
renderColumnsOn: html
	#( systemCategory class messageCategory message ) do: [ :each |
		html form
			class: 'browserBox';
			with: [
			| array |			
			array := self model perform: (each , 'List') asSymbol.
			html select
				size: 10;
				beSubmitOnChange;
				enabled: [ :x | self isEnabled: each ];
				list: array;
				selected: (array 
					at: (self model perform: (each , 'ListIndex') asSymbol)
					ifAbsent: []);
				callback: [ :item |
					(self isEnabled: each) ifTrue: [
						self model 
							perform: (each , 'ListIndex:') asSymbol 
							with: (array indexOf: item) ] ] ] ]! !

!PRVisitor methodsFor: '*HolyLight' stamp: 'pmm 7/28/2007 09:57'!
visitHolyLight: aHolyLight
	self visitComponent: aHolyLight! !

WAInspector subclass: #HLInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HolyLight'!

!HLInspector methodsFor: 'accessing' stamp: 'pmm 7/27/2007 07:12'!
doIt
	self inform: 'If this wasn''t a demo, your code would be executed now.'! !

!HLInspector methodsFor: 'accessing' stamp: 'pmm 7/27/2007 07:12'!
evaluate
	self inform: 'If this wasn''t a demo, your code would be evaluated now.'! !

!HLInspector methodsFor: 'accessing' stamp: 'pmm 7/27/2007 07:12'!
inspectIt
	self inform: 'If this wasn''t a demo, your code would be executed and displayed now.'! !

WAStylesHaloPlugin subclass: #HLStylesHaloPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HolyLight'!

!HLStylesHaloPlugin methodsFor: 'actions' stamp: 'pmm 7/27/2007 07:09'!
execute
	self open: (HLViewer on: self target)! !

WAViewer subclass: #HLViewer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HolyLight'!

!HLViewer methodsFor: 'accessing' stamp: 'pmm 7/27/2007 07:08'!
compile: aString
	self inform: 'If this wasn''t a demo, your changes would be accepted now.'! !

WABrowserHaloPlugin subclass: #HLBrowserHaloPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HolyLight'!

!HLBrowserHaloPlugin methodsFor: 'actions' stamp: 'pmm 7/27/2007 07:03'!
execute
	self open: (HLBrowser fullOnClass: self target class)! !

WAHalo subclass: #HLHalo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HolyLight'!

!HLHalo class methodsFor: 'instance-creation' stamp: 'pmm 7/28/2007 10:11'!
on: aComponent
	^ self new initializeOn: aComponent! !

!HLHalo methodsFor: 'private' stamp: 'pmm 7/28/2007 09:55'!
initializeOn: aComponent
	root := aComponent.
	mode := WAStateHolder new contents: self modes first.
	plugins := (self pluginClasses
		collect: [ :each | each on: aComponent for: self ]) asSortedCollection! !

!HLHalo methodsFor: 'private' stamp: 'pmm 7/28/2007 09:53'!
pluginClasses
	^Array
		with: HLBrowserHaloPlugin
		with: HLInspectorPlugin
		with: HLStylesHaloPlugin
		with: WAModeHaloPlugin! !

WAInspectorPlugin subclass: #HLInspectorPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HolyLight'!

!HLInspectorPlugin methodsFor: 'actions' stamp: 'pmm 7/27/2007 07:13'!
execute
	self open: (HLInspector on: self target)! !
